/* 
 * 
 * (c) Copyright Ascensio System Limited 2010-2014
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * http://www.gnu.org/licenses/agpl.html 
 * 
 */

#region Usings

using System;
using System.Runtime.Serialization;
using ASC.Api.Employee;
using ASC.Projects.Core.Domain;
using ASC.Projects.Core.Domain.Reports;
using ASC.Projects.Engine;
using ASC.Specific;

#endregion

namespace ASC.Api.Projects.Wrappers
{
    [DataContract(Name = "reportTemplate", Namespace = "")]
    public class ReportTemplateWrapper : ObjectWrapperFullBase
    {
        [DataMember]
        public bool AutoGenerated { get; set; }

        [DataMember]
        public string Cron { get; set; }

        [DataMember]
        public ReportType ReportType { get; set; }

        private ReportTemplateWrapper()
        {
        }

        public ReportTemplateWrapper(ReportTemplate reportTemplate)
        {
            Id = reportTemplate.Id;
            Title = reportTemplate.Name;
            Created = (ApiDateTime)reportTemplate.CreateOn;
            CreatedBy = EmployeeWraper.Get(reportTemplate.CreateBy);
            AutoGenerated = reportTemplate.AutoGenerated;
            Cron = reportTemplate.Cron;
            ReportType = reportTemplate.ReportType;
        }


        public static ReportTemplateWrapper GetSample()
        {
            return new ReportTemplateWrapper
            {
                Id = 1233,
                Title = "Sample ReportTemplate",
                Description = "Sample description",
                Created = (ApiDateTime)DateTime.Now,
                CreatedBy = EmployeeWraper.GetSample(),
            };
        }
    }
}
