/* 
 * 
 * (c) Copyright Ascensio System Limited 2010-2014
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * http://www.gnu.org/licenses/agpl.html 
 * 
 */

#region Usings

using System;

#endregion

namespace ASC.Projects.Core.Domain.Reports
{
    public class ReportTemplate
    {
        public int Id { get; set; }

        public string Name { get; set; }

        public ReportType ReportType { get; private set; }

        public TaskFilter Filter { get; set; }

        public string Cron { get; set; }

        public Guid CreateBy { get; set; }

        public DateTime CreateOn { get; set; }

        public bool AutoGenerated { get; set; }

        public int Tenant { get; set; }

        
        public ReportTemplate(ReportType reportType)
        {
            ReportType = reportType;
            AutoGenerated = false;
        }

        public override string ToString()
        {
            return Name;
        }

        public override bool Equals(object obj)
        {
            var t = obj as ReportTemplate;
            return t != null && Id.Equals(t.Id);
        }

        public override int GetHashCode()
        {
            return Id.GetHashCode();
        }
    }
}
