/* 
 * 
 * (c) Copyright Ascensio System Limited 2010-2014
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * http://www.gnu.org/licenses/agpl.html 
 * 
 */

using System;
using ASC.Web.UserControls.Wiki.Data;

namespace ASC.Web.UserControls.Wiki.UC
{
    public partial class ViewPage : BaseUserControl
    {
        private string _pageName = string.Empty;
        
        public string PageName
        {
            get { return PageNameUtil.Encode(_pageName); }
            set { _pageName = PageNameUtil.Decode(value); }
        }

        public int Version { get; set; }     

        public bool CanEditPage
        {
            get
            {
                if (ViewState["CanEditPage"] == null)
                    return false;
                return Convert.ToBoolean(ViewState["CanEditPage"]);
            }
            set { ViewState["CanEditPage"] = value; }
        }

        protected void Page_Load(object sender, EventArgs e) { }

        protected string RenderPageContent()
        {
            Page page;

            if (_pageName == null)
            {
                _pageName = string.Empty;
            }

            if (Version > 0)
            {
                page = Wiki.GetPage(_pageName, Version);
            }
            else
            {
                page = Wiki.GetPage(_pageName);
            }
            
            if (page == null)
            {
                return RenderEmptyPage();
            }

            RiseWikiPageLoaded(page);
            RisePublishVersionInfo(page);

            return HtmlWikiUtil.WikiToHtml(page.PageName, page.Body, Page.ResolveUrl(Request.AppRelativeCurrentExecutionFilePath), 
                Wiki.GetPagesAndFiles(page.Body), Page.ResolveUrl(ImageHandlerUrlFormat), 
                TenantId, CanEditPage && Version == 0 ? ConvertType.Editable : ConvertType.NotEditable);
        }

        protected string RenderEmptyPage()
        {
            RisePageEmptyEvent();
            return string.Empty; //HtmlWikiUtil.WikiToHtml(WikiUCResource.MainPage_EmptyPage);
        }
    }
}